----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:06:00 11/16/2011 
-- Design Name: 
-- Module Name:    Main - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
--********************************************************************************
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.ALL;

----------------------------------------------------------------------------------
entity Main is
    Port ( FIFO_Data: inout STD_LOGIC_VECTOR(7 downto 0); -- 8 Bit Datenbus
           RXF:          in STD_LOGIC;                    -- RX-Flag
           TXE:          in STD_LOGIC;                    -- TX Enable
           RD:          out STD_LOGIC;                    -- Read
           WR:          out STD_LOGIC;                    -- Write
           CLK:          in STD_LOGIC;                    -- Clock
           OE:          out STD_LOGIC;                    -- Output Enable

         --NAND_Data:  in STD_LOGIC_VECTOR(7 downto 0); -- 8 Bit Datenbus
         --CLE:  out STD_LOGIC;                         -- Command Latch Enable
         --ALE:  out STD_LOGIC;                         -- Adress Latch Enable
         --CE:   out STD_LOGIC;                         -- Chip Enable
         --RE:   out STD_LOGIC;                         -- Read Enable
         --WE:   out STD_LOGIC;                         -- Write Enable
         --WP:   out STD_LOGIC;                         -- Write Protection
         --RB:    in STD_LOGIC;                         -- Ready / Busy#
         --EXE:  out STD_LOGIC;                         -- Ext Flash Enable
           
           RST:   in STD_LOGIC;                         -- Reset-Button
           STA:   in STD_LOGIC;                         -- Start-Button
           Dig:  out STD_LOGIC_VECTOR(3 downto 0);      -- Digit 1..4, 7 Segmet Display
           Seg:  out STD_LOGIC_VECTOR(6 downto 0);      -- Segments A..G
           LEDs: out STD_LOGIC_VECTOR(3 downto 0));     -- LED 1..4
end Main;
--///////////////////////////////////////////////////////////////////
architecture Behavioral of Main is
  -- Types R/W State Machine FIFO
  type TFIFOReadStatus  is ( FIFO_RD_IDLE, FIFO_WAIT_RXF, FIFO_SET_OE, FIFO_SET_RD, FIFO_RD_DATA, FIFO_RD_DONE, FIFO_DUMMY1, FIFO_DUMMY2, FIFO_DUMMY3, FIFO_DUMMY4 );
--type TFIFOWriteStatus is ( FIFO_WR_IDLE, FIFO_SET_WR, FIFO_WR_DATA, FIFO_WR_DONE );

  -- Types R/W State Machine NAND
--type TNANDReadStatus  is ( NAND_IDLE,
--                           NAND_START_READ,   
--                           NAND_WRITE_CMD,
--                           NAND_RD_DATA,
--                           NAND_DONE);
  ---------------------------------------------------------
  signal CNT:     STD_LOGIC_VECTOR(15 downto 0) := (others => '1');
  signal RD_buf:  STD_LOGIC := '1';
  signal WR_buf:  STD_LOGIC := '1';
  signal OE_buf:  STD_LOGIC := '1';
  signal Dbg_1:   STD_LOGIC_VECTOR(3 downto 0) := (others => '0');
  signal Dbg_2:   STD_LOGIC_VECTOR(3 downto 0) := (others => '0');
  signal Dbg_3:   STD_LOGIC_VECTOR(3 downto 0) := (others => '0');
  signal Dbg_4:   STD_LOGIC_VECTOR(3 downto 0) := (others => '0');
  ---------------------------------------------------------
  component BinTo7Seg is
    Port ( E1, E2, E3, E4: in STD_LOGIC_VECTOR (3 downto 0);
           Sel:            in STD_LOGIC_VECTOR (1 downto 0);
           Digits:        out STD_LOGIC_VECTOR (3 downto 0);
           Segments:      out STD_LOGIC_VECTOR (6 downto 0));
  end component;
  ---------------------------------------------------------
begin

  CNTProc: process (CLK, RST)
    variable FIFOReadStatus:  TFIFOReadStatus;
    --variable NANDReadStatus:  TNANDReadStatus;
    --variable FIFOByteCounter: natural range 0 to 6;
    --variable NANDByteCounter: natural range 0 to 6;
    --variable Cmd1, Adr1, Adr2, Adr3, Adr4, Adr5, Cmd2: STD_LOGIC_VECTOR (7 downto 0);
    --type TBuf is array(0 to 6) of STD_LOGIC_VECTOR (7 downto 0);
    --variable CmdBuf: TBuf;
    --variable FIFOWriteStatus: TFIFOWriteStatus;
  begin
    if (RST = '0') then 
      CNT         <= (others => '1');
      FIFOReadStatus  := FIFO_RD_IDLE;
      --FIFOWriteStatus := FIFO_WR_IDLE; 
      --FIFOByteCounter := 0;
      RD_buf      <= '1';
      WR_buf      <= '1';
      OE_buf      <= '1';
      FIFO_Data   <= (others => 'Z');
      Dbg_1 <= (others => '0'); Dbg_2 <= (others => '0'); Dbg_3 <= (others => '0'); Dbg_4 <= (others => '0');      
    elsif (CLK'event) then 
      CNT <= CNT + 1;
      
--      case FIFOWriteStatus is
--        when FIFO_WR_IDLE  => if (STA = '0') AND (TXE = '0') then FIFOWriteStatus := FIFO_SET_WR; end if;
--        when FIFO_SET_WR   => WR <= '0';
--        when FIFO_WR_DATA  => FIFO_Data <= x"AA";
--        when FIFO_WR_DONE  => WR <= '1'; FIFO_Data <= (others => 'Z');
--      end case;
      
      case FIFOReadStatus is
        when FIFO_RD_IDLE  => if STA = '0' then
                                FIFOReadStatus := FIFO_WAIT_RXF;
                              end if;
        when FIFO_WAIT_RXF => if RXF = '0' then
                                FIFOReadStatus := FIFO_SET_OE;
                              end if;
        when FIFO_SET_OE   => OE_buf <= '0';
                              FIFOReadStatus := FIFO_SET_RD;
        when FIFO_SET_RD   => RD_buf <= '0';
                              FIFOReadStatus := FIFO_RD_DATA;
        when FIFO_RD_DATA  => if RXF = '1' then
                                FIFOReadStatus := FIFO_RD_DONE;
                              else
                                --CmdBuf(FIFOByteCounter) := Data;
                                --if FIFOByteCounter = 6 then
                                --  FIFOReadStatus := FIFO_RD_DONE;
                                --  NANDReadStatus := NAND_WRITE_CMD;
                                --  CNT(0) := 0;
                                --else
                                --  FIFOByteCounter := FIFOByteCounter + 1;
                                --end if;
                                Dbg_3 <= FIFO_Data(7 downto 4);
                                Dbg_4 <= FIFO_Data(3 downto 0);
                              end if;
        when FIFO_RD_DONE  => RD_buf <= '1'; OE_buf <= '1';
                              FIFOReadStatus := FIFO_WAIT_RXF;
        when others        => FIFOReadStatus := FIFO_RD_IDLE; -- fr Dummys
      end case;

--    if CNT(0) = '1' then -- halbe Taktfrequenz
--      case NANDReadStatus is
--
--        when NAND_IDLE       => Null;
--        when NAND_START_READ => NANDByteCounter := 0;
--                                CE <= '0';
--                                WE <= '0';
--                                NANDReadStatus := NAND_WRITE_CMD1;                                  
--        when NAND_WRITE_CMD  => NAND_Data <= CmdBuf(NANDByteCounter);
--                                WE <= '0'; 
--                                case NANDByteCounter is
--                                  when 0      => ALE <= '0';
--                                                 CLE <= '1';
--                                  when 1 to 5 => ALE <= '1';
--                                                 CLE <= '0';
--                                  when 6      => ALE <= '0';
--                                                 CLE <= '1';
--                                end case;
--                                NANDByteCounter := NANDByteCounter + 1;
--        when NAND_RD_DATA    => Null;
--        when NAND_DONE       => Null;
--      end case;
--    elsif (NANDReadStatus = NAND_WRITE_CMD) AND (NANDByteCounter > 0) AND (NANDByteCounter < 5) then
--      WE <= 1;
--    end if;
      
      Dbg_1 <= std_logic_vector(to_unsigned(TFIFOReadStatus'pos(FIFOReadStatus), 4));
      --Dbg_2 <= std_logic_vector(to_unsigned(TNANDReadStatus'pos(NANDReadStatus), 4));

    end if;
  end process;
  
  OE <= OE_buf;
  RD <= RD_buf;
  WR <= WR_buf;
  
  LEDs(0) <= not TXE;
  LEDs(1) <= not RXF;
  LEDs(2) <= not OE_buf;
  LEDs(3) <= not RD_buf;

  I_7Seg: BinTo7Seg port map (Dbg_1, Dbg_2, Dbg_3, Dbg_4, CNT(15 downto 14), Dig, Seg);

end Behavioral;
--********************************************************************************
