----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:47:36 11/24/2011 
-- Design Name: 
-- Module Name:    NAND_Command - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
--********************************************************************************
entity NAND_Command is
    Port ( CLK:      in STD_LOGIC;
           RST:      in STD_LOGIC;
           RB:       in STD_LOGIC;
           CLE:     out STD_LOGIC;
           WE:      out STD_LOGIC;
           DataIn:   in STD_LOGIC_VECTOR(7 downto 0);
           DataOut: out STD_LOGIC_VECTOR(7 downto 0));
end NAND_Command;
--********************************************************************************
architecture Behavioral of NAND_Command is
  type TCMDStatus is ( IDLE, WAIT_READY, SET_CMD, RES_WE, WAIT_BUSY);
begin
  CmdProc: process (CLK, RST)
    variable Status: TCMDStatus;
  begin
    if RST = 0 then
      Status := IDLE;
    elsif rising_edge(CLK) then
      case Status is
        when IDLE       => Null;
        when WAIT_READY => if RB = '1' then
                             CLE <= '1';
                             Status := SET_CMD;
                           end if;
        when SET_CMD    => WE <= '0';
                           DataOut <= DataIn;
                           Status := RES_WE;
        when RES_WE     => WE <= '1';
                           Status := WAIT_BUSY;
        when WAIT_BUSY  => if RB = '0' then
                             CLE <= '0';
                             Status := IDLE;
                           end if;
      end case;      
    end if;
  end process;
end Behavioral;
--********************************************************************************
